#!/usr/bin/env python
# Software License Agreement (BSD License)
#
# Copyright (c) 2008, Willow Garage, Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#  * Neither the name of Willow Garage, Inc. nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Revision $Id: test_rospy_api.py 4800 2009-06-10 19:59:00Z gerkey $

import roslib; roslib.load_manifest('test_rospy')

import os
import sys
import struct
import unittest
import time

# test rospy API verifies that the rospy module exports the required symbols
class TestRospyApi(unittest.TestCase):

    def test_rospy_api(self):
        import rospy

        # just a laundry list of API methods to make sure that they still exist
        
        # deprecated
        rospy.TopicPub, rospy.TopicSub
        rospy.ready        

        # removed
        try:
            rospy.add_shutdown_hook
            self.fail("add_shutdown_hookshould not longer be top-level API")
        except AttributeError: pass

        rospy.get_caller_id
        rospy.get_master
        rospy.get_namespace
        rospy.get_published_topics
        rospy.get_node_proxy
        rospy.get_node_uri
        rospy.get_ros_root
        rospy.get_time
        rospy.get_rostime
        rospy.init_node
        rospy.is_shutdown
        rospy.logdebug
        rospy.logerr
        rospy.logfatal
        rospy.loginfo        
        rospy.logout #deprecated
        rospy.logwarn
        rospy.myargv
        rospy.on_shutdown
        rospy.parse_rosrpc_uri
        rospy.resolve_name
        rospy.signal_shutdown
        rospy.sleep
        rospy.spin
        rospy.wait_for_service

        rospy.delete_param
        rospy.get_param
        rospy.get_param_names
        rospy.has_param
        rospy.set_param

        rospy.AnyMsg
        rospy.Duration
        rospy.Header
        rospy.Message
        rospy.Publisher
        rospy.Rate
        rospy.ROSException
        rospy.ROSInternalException
        rospy.ROSSerializationException
        rospy.ServiceDefinition
        rospy.ServiceException
        rospy.Service
        rospy.ServiceProxy
        rospy.SubscribeListener
        rospy.Subscriber        
        rospy.Time
        rospy.TransportException
        rospy.TransportTerminated
        rospy.TransportInitError
        
if __name__ == '__main__':
    import rostest
    rostest.unitrun('test_rospy', sys.argv[0], TestRospyApi)
